#
#   @(#)make.inc	7.26 02/11/18
#
#   make.inc for xmcd, cda and libdi
#
#	xmcd  - Motif(R) CD Audio Player/Ripper
#	cda   - Command-line CD Audio Player/Ripper
#	libdi - CD Audio Device Interface Library
#	cddb  - CD Database Management Library
#
#   NOTE: You should use this only if you don't have imake!
#
#   Copyright (C) 1993-2002  Ti Kan
#   E-mail: xmcd@amb.org
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

#
# This sample make.inc file is set up for compilation on a UnixWare 2.1.x
# system.  Modify these as you see fit.  You will most certainly need to
# make some changes here in order to successfully build xmcd/cda
# on your platform.
#

#
# For the TIMER= line, use one of the following:
#	-DUSE_SELECT
#	-DUSE_POLL
#	-DUSE_USLEEP
#	-DUSE_NAP
#
# For the TERMIO= line, use one of the following:
#	-DUSE_TERMIOS
#	-DUSE_TERMIO
#	-DUSE_SGTTY
#
# For the MISC= line, you should use any of the following if appropriate
# for your platform:
#	-DBSDCOMPAT
#	-DHAS_SETUID
#	-DHAS_ICONV
#	-DHAS_ALSA		(Linux only)
#	-DHAS_LAME
#	-DHAS_VORBIS
#	-DNO_STDLIB_H
#	-DNO_UNISTD_H
#	-DNO_LABELH
#
# See the Imakefiles in each of the subdirectories for an explanation of
# these defines.
#
SHELL=		/bin/sh
MAKE=		make
CC=		cc
RANLIB=		/bin/true
AR=		ar cq
RM=		rm -f
LN=		ln -s
CFLAGS=		-O $(DEFINES) $(INCDIRS) $(ARCH) $(TIMER) $(TERMIO) $(MISC)
ARCH=		-DSVR4 -Di386
MISC=		-DHAS_SETEUID -DHAS_ICONV -DHAS_LAME -DHAS_VORBIS
TIMER=		-DUSE_SELECT
TERMIO=		-DUSE_TERMIOS
INCDIRS=	-I.. -I/usr/X/include -I/usr/local/include
LOCAL_LIBDIR=	-L/usr/local/lib
CDDBLIB=	-L../cddb_d -lcddb
VORBLIB=	-lvorbisenc -lvorbis -logg
# LAMELIB=	-lmp3lame
# AUDIOLIB=	-lasound
XLIBS=		-L/usr/X/lib -lXm -lXt -lX11 -lgen
CURSESLIB=	-lcurses
SOCKETLIB=	-lsocket -lnsl
MATHLIB=	-lm
BINDIR=		/usr/bin/X11
LIBDIR=		/usr/lib/X11
MANDIR=		/usr/man/man1
MANSUF=		.1
DEPEND=		makedepend
DEPENDFLAGS=
TAGS=		ctags

